
var cc        ${c}$                    (long_name='Consumption')
    rr        ${r}$                    (long_name='nominal interest rate')
    hh        ${h}$                    (long_name='labor')
    chch      ${c^h}$                  (long_name='domestic goods consumption')
    phph      ${p^h}$                  (long_name='domestic goods price')
    cfcf      ${c^f}$                  (long_name='Imports')
    pfpf      ${p^f}$                  (long_name='Price of imports')
    chschs    ${(c^h)^\ast}$           (long_name='Exports')
    cscs      ${c^\ast}$               (long_name='Exo foreign consumption')
    ss        ${s}$                    (long_name='Nominal exchange rate')
    psps      ${p^\ast}$               (long_name='International price')    
    bb        ${B}$                    (long_name='Domestic currency bonds')
    rsrs      ${R^\ast}$               (long_name='foreign interest rate')
    dsds      ${D^\ast}$               (long_name='Dealers position')
    aa        ${a}$                    (long_name='TFP')
    mcmc      ${mc}$                   (long_name='Marginal cost')
    nsns      ${N^\ast}$               (long_name='Noise traders')
    yy        ${y}$                    (long_name='output')
    zhzh      ${z^h}$                  (long_name='domestic goods investing') 
    zfzf      ${z^f}$                  (long_name='foreign goods investing')
    kk        ${k}$                    (long_name='capital')
    rkrk      ${r^k}$                  (long_name='return on capital')
    ww        ${w}$                    (long_name='wage')
    zz        ${z}$                    (long_name='investment')
    ca        ${ca}$                   (long_name='current account')
    yhyh      ${y^h}$
;

varexo  eps_a   ${\varepsilon_a}$   (long_name='technology shock')
        eps_psi ${\varepsilon_{\psi}}$   (long_name='portfolio flows shock')
;

load PARAML;
load PARAMSS;

parameters   
BBETA       ${\beta}$                   (long_name='discount')
MMU         ${\mu}$                     (long_name='home bias')
NNU         ${\nu}$                     (long_name='inverse Frisch elasticity')
MMBAR       ${\bar{M}}$                 (long_name='dealers risk capacity')
OOMEGA      ${\omega}$                  (long_name='CARA risk aversion')
SSIGMA      ${\sigma}$                  (long_name='exchange rate risk')
RHOA        ${\rho^{a}}$                (long_name='AR(1) parameter')
RHONST      ${\rho({n^{\ast}})}$        (long_name='AR(1) parameter')
STD_PSI     ${\sigma_{\psi}}$           (long_name='st. dev. portfolio shock')
STD_A       ${\sigma_{a}}$              (long_name='st. dev. technology shock')
GGAMMA      ${\gamma}$                  (long_name='Inverse of the IES')
VVARTHETA   ${\vartheta}$               (long_name='share of capital')
VVAREPSILON ${\varepsilon}$             (long_name='price elasticity')
KKAPPA      ${\kappa}$                  (long_name='adjustment cost parameter')
DDELTA      ${\delta}$                  (long_name='depreciation')
ss_ss hh_ss kk_ss cc_ss aa_ss rsrs_ss rr_ss pp_ss psps_ss cscs_ss yy_ss zhzh_ss zfzf_ss phph_ss chch_ss cfcf_ss chschs_ss ww_ss rkrk_ss zz_ss mcmc_ss pfpf_ss bb_ss nsns_ss dsds_ss ca_ss
;


set_param_value('BBETA',BBETA)
set_param_value('DDELTA',DDELTA)
set_param_value('GGAMMA',GGAMMA)
set_param_value('KKAPPA',KKAPPA)
set_param_value('MMBAR',MMBAR)
set_param_value('MMU',MMU)
set_param_value('NNU',NNU)
set_param_value('OOMEGA',OOMEGA)
set_param_value('RHOA',RHOA)
set_param_value('RHONST',RHONST)
set_param_value('SSIGMA',SSIGMA)
set_param_value('STD_A',STD_A)
set_param_value('STD_PSI',STD_PSI)
set_param_value('VVAREPSILON',VVAREPSILON)
set_param_value('VVARTHETA',VVARTHETA)
set_param_value('ss_ss',ss_ss)
set_param_value('hh_ss',hh_ss)
set_param_value('kk_ss',kk_ss)
set_param_value('cc_ss',cc_ss)
set_param_value('aa_ss',aa_ss)
set_param_value('rsrs_ss',rsrs_ss)
set_param_value('rr_ss',rr_ss)
set_param_value('pp_ss',pp_ss)
set_param_value('psps_ss',psps_ss)
set_param_value('cscs_ss',cscs_ss)
set_param_value('yy_ss',yy_ss)
set_param_value('zhzh_ss',zhzh_ss)
set_param_value('zfzf_ss',zfzf_ss)
set_param_value('phph_ss',phph_ss)
set_param_value('chch_ss',chch_ss)
set_param_value('cfcf_ss',cfcf_ss)
set_param_value('chschs_ss',chschs_ss)
set_param_value('ww_ss',ww_ss)
set_param_value('rkrk_ss',rkrk_ss)
set_param_value('zz_ss',zz_ss)
set_param_value('mcmc_ss',mcmc_ss)
set_param_value('pfpf_ss',pfpf_ss)
set_param_value('bb_ss',bb_ss)
set_param_value('nsns_ss',nsns_ss)
set_param_value('dsds_ss',dsds_ss)
set_param_value('ca_ss',ca_ss)

model(linear);
[name='1. Euler']
-GGAMMA*cc = -GGAMMA*cc(+1) + rr;

[name='2. labor suppply']
GGAMMA*cc + NNU*hh = ww;

[name='3. Euler investment']
rkrk(+1) = rr +  KKAPPA * (kk - kk(-1)) - KKAPPA * (kk(+1) - kk);

[name='4. Investment']
zz = kk - (1-DDELTA)*kk(-1);

[name='5. Domestic demand']
chch = -VVAREPSILON*phph + cc;

[name='6. Imports']
cfcf = -VVAREPSILON*pfpf + cc;

[name='7. Exports']
chschs = -VVAREPSILON*(phph - ss - psps) + cscs;

[name='8. CPI']
0 = MMU*phph + (1-MMU)*pfpf;

[name='9. Mod Uip']
ss = ss(+1) -  rr + rsrs  - OOMEGA/MMBAR * (SSIGMA^2) * (dsds); 

[name='10. Production function']
yy = aa + VVARTHETA*kk(-1) + (1-VVARTHETA)*hh;

[name='11. Capital demand']
phph + yy - kk(-1) = rkrk;

[name='12. Labor demand']
phph + yy - hh = ww;

[name='13. MgC']
mcmc = (1-VVARTHETA)*ww + VVARTHETA*rkrk - aa;

[name='14. LOOP']
pfpf = ss + psps;

[name='15. Goods equilibrium']
yy = MMU*yhyh + (1-MMU)*chschs;

[name='16. Domestic Goods equilibrium']
yhyh = (chch_ss/(chch_ss + zhzh_ss))*chch + (zhzh_ss/(chch_ss + zhzh_ss))*zhzh;

[name='17. Domestic goods for investment demand']
zhzh = -VVAREPSILON*phph + zz;

[name='18. Imported goods for investment demand']
zfzf = -VVAREPSILON*pfpf + zz;

[name='19. Financial equilibrium']
(bb) = (ss_ss)*((nsns) + (dsds));

[name='20. CA']
ca = ss_ss*(dsds - dsds(-1) + nsns - nsns(-1));

[name='21. TPF shock']
(aa) = RHOA*(aa(-1)) + STD_A * eps_a;

[name='22. Exo']
cscs = 0;

[name='23. Exo']
psps = 0;

[name='24. NSNS shock']
(nsns) = RHONST * (nsns(-1)) + STD_PSI * eps_psi;

[name='25. Exo']
(rsrs) = 0;

[name='25. CA']
ca = phph_ss*chschs_ss*(phph + chschs) - pfpf_ss*cfcf_ss*(pfpf + cfcf) - pfpf_ss*zfzf_ss*(pfpf + zfzf) + ss_ss * (1/BBETA -1) * (dsds(-1) + nsns(-1));

end;


initval;
ss = 0;
hh = 0;
cc = 0;
kk = 0;
aa = 0;
rsrs = 0;
rr = 0;
psps = 0;
cscs = 0;
yy = 0;
zhzh = 0;
zfzf = 0;
phph = 0;
chch = 0;
cfcf = 0;
chschs = 0;
ww = 0;
rkrk = 0;
zz = 0;
mcmc = 0;
pfpf = 0;
bb = 0;
nsns = 0;
dsds = 0;
ca = 0;
yhyh = 0;
end;


write_latex_dynamic_model;
steady;
check;

shocks;
    var eps_a= 0.1;
    //var eps_psi; stderr 0.1;
end;

stoch_simul(order=1,hp_filter=1600,simul_replic=10000,periods=120) yy cc ca ss zz hh rr ;
