
var cc        ${c}$                    (long_name='Consumption')
    rr        ${r}$                    (long_name='nominal interest rate')
    pp        ${p}$                    (long_name='cpi')
    hh        ${h}$                    (long_name='labor')
    chch      ${c^h}$                  (long_name='domestic goods consumption')
    phph      ${p^h}$                  (long_name='domestic goods price')
    cfcf      ${c^f}$                  (long_name='Imports')
    pfpf      ${p^f}$                  (long_name='Price of imports')
    chschs    ${(c^h)^\ast}$           (long_name='Exports')
    cscs      ${c^\ast}$               (long_name='Exo foreign consumption')
    ss        ${s}$                    (long_name='Nominal exchange rate')
    psps      ${p^\ast}$               (long_name='International price')    
    bb        ${B}$                    (long_name='Domestic currency bonds')
    rsrs      ${R^\ast}$               (long_name='foreign interest rate')
    dsds      ${D^\ast}$               (long_name='Dealers position')
    aa        ${a}$                    (long_name='TFP')
    mcmc      ${mc}$                   (long_name='Marginal cost')
    nsns      ${N^\ast}$               (long_name='Noise traders')
    yy        ${y}$                    (long_name='output')
    zhzh      ${z^h}$                  (long_name='domestic goods investing') 
    zfzf      ${z^f}$                  (long_name='foreign goods investing')
    kk        ${k}$                    (long_name='capital')
    rkrk      ${r^k}$                  (long_name='return on capital')
    ww        ${w}$                    (long_name='wage')
    zz        ${z}$                    (long_name='investment')
    ca        ${ca}$                   (long_name='current account')
;

varexo  eps_a   ${\varepsilon_a}$   (long_name='technology shock')
        eps_psi ${\varepsilon_{\psi}}$   (long_name='portfolio flows shock')
;

load PARAML;
load PARAMSS;

parameters   
BBETA       ${\beta}$                   (long_name='discount')
MMU         ${\mu}$                     (long_name='home bias')
NNU         ${\nu}$                     (long_name='inverse Frisch elasticity')
MMBAR       ${\bar{M}}$                 (long_name='dealers risk capacity')
OOMEGA      ${\omega}$                  (long_name='CARA risk aversion')
SSIGMA      ${\sigma}$                  (long_name='exchange rate risk')
RHOA        ${\rho^{a}}$                (long_name='AR(1) parameter')
RHONST      ${\rho({n^{\ast}})}$        (long_name='AR(1) parameter')
STD_PSI     ${\sigma_{\psi}}$           (long_name='st. dev. portfolio shock')
STD_A       ${\sigma_{a}}$              (long_name='st. dev. technology shock')
GGAMMA      ${\gamma}$                  (long_name='Inverse of the IES')
VVARTHETA   ${\vartheta}$               (long_name='share of capital')
VVAREPSILON ${\varepsilon}$             (long_name='price elasticity')
KKAPPA      ${\kappa}$                  (long_name='adjustment cost parameter')
DDELTA      ${\delta}$                  (long_name='depreciation')
ss_ss hh_ss kk_ss cc_ss aa_ss rsrs_ss rr_ss pp_ss psps_ss cscs_ss yy_ss zhzh_ss zfzf_ss phph_ss chch_ss cfcf_ss chschs_ss ww_ss rkrk_ss zz_ss mcmc_ss pfpf_ss bb_ss nsns_ss dsds_ss ca_ss
;


set_param_value('BBETA',BBETA)
set_param_value('DDELTA',DDELTA)
set_param_value('GGAMMA',GGAMMA)
set_param_value('KKAPPA',KKAPPA)
set_param_value('MMBAR',MMBAR)
set_param_value('MMU',MMU)
set_param_value('NNU',NNU)
set_param_value('OOMEGA',OOMEGA)
set_param_value('RHOA',RHOA)
set_param_value('RHONST',RHONST)
set_param_value('SSIGMA',SSIGMA)
set_param_value('STD_A',STD_A)
set_param_value('STD_PSI',STD_PSI)
set_param_value('VVAREPSILON',VVAREPSILON)
set_param_value('VVARTHETA',VVARTHETA)
set_param_value('ss_ss', ss_ss)
set_param_value('hh_ss', hh_ss)
set_param_value('kk_ss', kk_ss)
set_param_value('cc_ss', cc_ss)
set_param_value('aa_ss', aa_ss)
set_param_value('rsrs_ss', rsrs_ss)
set_param_value('rr_ss', rr_ss)
set_param_value('pp_ss', pp_ss)
set_param_value('psps_ss', psps_ss)
set_param_value('cscs_ss', cscs_ss)
set_param_value('yy_ss', yy_ss)
set_param_value('zhzh_ss', zhzh_ss)
set_param_value('zfzf_ss', zfzf_ss)
set_param_value('phph_ss', phph_ss)
set_param_value('chch_ss', chch_ss)
set_param_value('cfcf_ss', cfcf_ss)
set_param_value('chschs_ss', chschs_ss)
set_param_value('ww_ss', ww_ss)
set_param_value('rkrk_ss', rkrk_ss)
set_param_value('zz_ss', zz_ss)
set_param_value('mcmc_ss', mcmc_ss)
set_param_value('pfpf_ss', pfpf_ss)
set_param_value('bb_ss', bb_ss)
set_param_value('nsns_ss', nsns_ss)
set_param_value('dsds_ss', dsds_ss)
set_param_value('ca_ss', ca_ss)

model;
[name='1. Euler']
(cc)^(-GGAMMA)=BBETA*(cc(+1))^(-GGAMMA)*(rr)*(pp)/(pp(+1));

[name='2. labor suppply']
(hh)^(NNU)*(cc)^(GGAMMA) = (ww)/(pp);

[name='3. Euler investment']
(1+KKAPPA*((kk)-(kk(-1))))=BBETA*((cc(+1))/(cc))^(-GGAMMA)*((rkrk(+1))+KKAPPA*((kk(+1))-(kk))+1-DDELTA);

[name='4. Investment']
(kk) = (1-DDELTA)*(kk(-1)) + (zz);

[name='5. Domestic demand']
(chch) = MMU*((phph)/(pp))^(-VVAREPSILON)*(cc);

[name='6. Imports']
(cfcf) = (1-MMU)*((pfpf)/(pp))^(-VVAREPSILON)*(cc);

[name='7. Exports']
(chschs) = (1-MMU)*((phph)/((psps)*(ss)))^(-VVAREPSILON)*(cscs);

[name='8. cpi']
(pp) = (MMU*(phph)^(1-VVAREPSILON) + (1-MMU)*(pfpf)^(1-VVAREPSILON))^(1/1-VVAREPSILON);

[name='9. Mod uip']
ss = ss(+1) -  rr + rsrs  - OOMEGA/MMBAR * (SSIGMA^2) * (dsds); 

[name='10. Production function']
(yy) = (aa)*(kk(-1))^VVARTHETA*(hh)^(1-VVARTHETA);

[name='11. Capital demand']
(phph)*(aa)*VVARTHETA*(yy)/(kk(-1)) = (rkrk);

[name='12. Labor demand']
(phph)*(aa)*(1-VVARTHETA)*(yy)/(hh) = (ww);

[name='13. MgC']
(mcmc) = 1/(VVARTHETA^VVARTHETA*(1-VVARTHETA)^(1-VVARTHETA))*(1/((aa)))*((rkrk)^VVARTHETA*(ww)^(1-VVARTHETA));

[name='14. LOOP']
(pfpf) = (ss)*(psps);

[name='15. Goods equilibrium']
(yy) = (chch) + (chschs) + (zhzh);

[name='16. Domestic goods for investment demand']
(zhzh) = MMU*((phph)/(pp))^(-VVAREPSILON)*(zz);

[name='17. Imported goods for investment demand']
(zfzf) = (1-MMU)*((pfpf)/(pp))^(-VVAREPSILON)*(zz);

[name='18. FInancial equilibrium']
(bb) = (ss)*((nsns) + (dsds));

[name='19. CA']
(ss)*(rr(-1))*(nsns(-1)) + (phph)*(chschs) - (pfpf)*(cfcf) - (pfpf)*(zfzf) + (ss)*(rsrs(-1))*(dsds(-1)) = (ss)*(nsns) + (ss)*(dsds);

[name='20. walras']
(pp) = 1;

[name='21. TPF shock']
log(aa) = RHOA*log(aa(-1)) + STD_A * eps_a;

[name='22. Exo']
(cscs) = 1;

[name='23. Exo']
(psps) = 1;

[name='24. NSNS shock']
(nsns) = RHONST * (nsns(-1)) + STD_PSI * eps_psi;

[name='25. Exo']
(rsrs) = 1/BBETA;

[name='25. CA']
(ca) = (ss)*((dsds) - (dsds(-1)) + (nsns) - (nsns(-1)));

end;

steady_state_model;
ss = (ss_ss);
hh = (hh_ss);
cc = (cc_ss);
kk = (kk_ss);
aa = 1;
rsrs = (1/BBETA);
rr = (1/BBETA);
pp = (1);
psps = (1);
cscs = (1);
yy = (kk_ss^VVARTHETA*hh_ss^(1-VVARTHETA));
zhzh = (MMU*( (1 - (1-MMU)*ss_ss^(1-VVAREPSILON)) / MMU)^(-VVAREPSILON/(1-VVAREPSILON)) * DDELTA*kk_ss);
zfzf = ((1-MMU)*ss_ss^(-VVAREPSILON)*DDELTA*kk_ss);
phph = (( (1 - (1-MMU)*ss_ss^(1-VVAREPSILON)) / MMU)^(1/(1-VVAREPSILON)));
chch = (MMU*( (1 - (1-MMU)*ss_ss^(1-VVAREPSILON)) / MMU)^(-VVAREPSILON/(1-VVAREPSILON))*cc_ss);
cfcf = ((1-MMU)*ss_ss^(-VVAREPSILON)*cc_ss);
chschs = ((1-MMU)*( (1 - (1-MMU)*ss_ss^(1-VVAREPSILON)) / MMU)^(-VVAREPSILON/(1-VVAREPSILON))*ss_ss^VVAREPSILON);
ww = (hh_ss^NNU*cc_ss^GGAMMA);
rkrk = (1/BBETA - 1 + DDELTA);
zz = (DDELTA*kk_ss);
mcmc = (1/(VVARTHETA^VVARTHETA*(1-VVARTHETA)^(1-VVARTHETA))*((1/BBETA - 1 + DDELTA)^VVARTHETA*(hh_ss^NNU*cc_ss^GGAMMA)^(1-VVARTHETA)));
pfpf = (ss_ss);
bb = 0;
nsns = 0;
dsds = 0;
ca = 0;
end;


write_latex_dynamic_model;
steady;
check;

shocks;
    var eps_a= 0.1;
    //var eps_psi; stderr 0.1;
end;

stoch_simul(order=1,hp_filter=1600,simul_replic=10000,periods=120) yy cc ca ss zz hh rr ;

%----------------------------------------------------------------
% Compute Variances 
%----------------------------------------------------------------

yy_pos = strmatch('yy',var_list_,'exact')
cc_pos = strmatch('cc',var_list_,'exact')
zz_pos = strmatch('zz',var_list_,'exact')
ww_pos = strmatch('ww',var_list_,'exact')
ca_pos = strmatch('ca',var_list_,'exact')

stdv.yy = sqrt(oo_.var(yy_pos,yy_pos));
stdv.cc = sqrt(oo_.var(cc_pos,cc_pos));
stdv.zz = sqrt(oo_.var(zz_pos,zz_pos));
stdv.ww = sqrt(oo_.var(ww_pos,ww_pos));
stdv.ca = sqrt(oo_.var(ca_pos,ca_pos));

corre.yy.yy = oo_.var(yy_pos,yy_pos)/(stdv.yy*stdv.yy);
corre.yy.cc = oo_.var(yy_pos,cc_pos)/(stdv.yy*stdv.cc);
corre.yy.zz = oo_.var(yy_pos,zz_pos)/(stdv.yy*stdv.zz);
corre.yy.ww = oo_.var(yy_pos,ww_pos)/(stdv.yy*stdv.ww);
corre.yy.ca = oo_.var(yy_pos,ca_pos)/(stdv.yy*stdv.ca);

values_all_k = [stdv.yy; stdv.cc; stdv.zz; stdv.ww; stdv.ca; corre.yy.yy; corre.yy.cc; corre.yy.zz; corre.yy.ww; corre.yy.ca];
num_elements = length(values_all_k) / 2;
values_all_k = reshape(values_all_k, num_elements, 2);

% save values_all_k
