clear;
clc;
format long;  
close all;

BBETA = 0.9615;
DDELTA = 0.1;
GGAMMA = 2;
KKAPPA = 0;
MMBAR = 1;
MMU = 0.85;
NNU = 1.455;
OOMEGA = 0.01;
RHOA = 0.42;
RHONST = 0.97;
SSIGMA = 1;
STD_A = 1;
STD_PSI = 1;
VVAREPSILON = 1.5;
VVARTHETA = 0.32;

save PARAML BBETA DDELTA GGAMMA KKAPPA MMBAR MMU NNU OOMEGA RHOA RHONST SSIGMA STD_A STD_PSI VVAREPSILON VVARTHETA;

PARAML(1,1) = BBETA;
PARAML(2,1) = DDELTA;
PARAML(3,1) = GGAMMA;
PARAML(4,1) = KKAPPA;
PARAML(5,1) = MMBAR;
PARAML(6,1) = MMU;
PARAML(7,1) = NNU;
PARAML(8,1) = OOMEGA;
PARAML(9,1) = RHOA;
PARAML(10,1) = RHONST;
PARAML(11,1) = SSIGMA;
PARAML(12,1) = STD_A;
PARAML(13,1) = STD_PSI;
PARAML(14,1) = VVAREPSILON;
PARAML(15,1) = VVARTHETA;

initial_guess = [0.7 1.5 4];

options = optimoptions('fsolve', 'Display', 'iter');

[solution, fval, exitflag] = fsolve(@(vars) mySystem(vars, PARAML), initial_guess, options);

ss_ss = solution(1);
hh_ss = solution(2);
kk_ss = solution(3);
cc_ss = (((1/BBETA - 1 + DDELTA)*kk_ss)/(hh_ss^(1+NNU)) * (1-VVARTHETA)/(VVARTHETA) )^(1/GGAMMA);
aa_ss = 1;
rsrs_ss = (1/BBETA);
rr_ss = (1/BBETA);
pp_ss = (1);
psps_ss = (1);
cscs_ss = (1);
yy_ss = (kk_ss^VVARTHETA*hh_ss^(1-VVARTHETA));
zhzh_ss = (MMU*( (1 - (1-MMU)*ss_ss^(1-VVAREPSILON)) / MMU)^(-VVAREPSILON/(1-VVAREPSILON)) * DDELTA*kk_ss);
zfzf_ss = ((1-MMU)*ss_ss^(-VVAREPSILON)*DDELTA*kk_ss);
phph_ss = (( (1 - (1-MMU)*ss_ss^(1-VVAREPSILON)) / MMU)^(1/(1-VVAREPSILON)));
chch_ss = (MMU*( (1 - (1-MMU)*ss_ss^(1-VVAREPSILON)) / MMU)^(-VVAREPSILON/(1-VVAREPSILON))*cc_ss);
cfcf_ss = ((1-MMU)*ss_ss^(-VVAREPSILON)*cc_ss);
chschs_ss = ((1-MMU)*( (1 - (1-MMU)*ss_ss^(1-VVAREPSILON)) / MMU)^(-VVAREPSILON/(1-VVAREPSILON))*ss_ss^VVAREPSILON);
ww_ss = (hh_ss^NNU*cc_ss^GGAMMA);
rkrk_ss = (1/BBETA - 1 + DDELTA);
zz_ss = (DDELTA*kk_ss);
mcmc_ss = (1/(VVARTHETA^VVARTHETA*(1-VVARTHETA)^(1-VVARTHETA))*((1/BBETA - 1 + DDELTA)^VVARTHETA*(hh_ss^NNU*cc_ss^GGAMMA)^(1-VVARTHETA)));
pfpf_ss = (ss_ss);
bb_ss = 0;
nsns_ss = 0;
dsds_ss = 0;
ca_ss = 0;


PARAMSS(1,1) = ss_ss;
PARAMSS(2,1) = hh_ss;
PARAMSS(3,1) = kk_ss;
PARAMSS(4,1) = cc_ss;
PARAMSS(5,1) = aa_ss;
PARAMSS(6,1) = rsrs_ss;
PARAMSS(7,1) = rr_ss;
PARAMSS(8,1) = pp_ss;
PARAMSS(9,1) = psps_ss;
PARAMSS(10,1) = cscs_ss;
PARAMSS(11,1) = yy_ss;
PARAMSS(12,1) = zhzh_ss;
PARAMSS(13,1) = zfzf_ss;
PARAMSS(14,1) = phph_ss;
PARAMSS(15,1) = chch_ss;
PARAMSS(16,1) = cfcf_ss;
PARAMSS(17,1) = chschs_ss;
PARAMSS(18,1) = ww_ss;
PARAMSS(19,1) = rkrk_ss;
PARAMSS(20,1) = zz_ss;
PARAMSS(21,1) = mcmc_ss;
PARAMSS(22,1) = pfpf_ss;
PARAMSS(23,1) = bb_ss;
PARAMSS(24,1) = nsns_ss;
PARAMSS(25,1) = dsds_ss;
PARAMSS(26,1) = ca_ss;

save PARAMSS

dynare model_k
dynare linear






